'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.indexer = indexer;

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function indexer(ast, script) {
  var indexes = script.indexes;

  indexes._importNodes = [];
  indexes._exportNodes = [];
  indexes._classProperties = {};

  var index = 0;

  (0, _babelTraverse2.default)(ast, {
    enter: function enter(path) {
      if (t.isClassProperty(path.node)) {
        var key = path.node.key && path.node.key.name;

        if (key) {
          indexes._classProperties[key] = path.node;
        }
      }

      if (t.isImportDeclaration(path.node)) {
        indexes._importNodes.push(path.node);
      }

      if (t.isExportDeclaration(path.node)) {
        indexes._exportNodes.push(path.node);
      }

      index = index + 1;
    }
  });

  return ast;
}

exports.default = indexer;